3 # B A C K U P N I N J A /()/
6 # Copyright (C) 2004-05 riseup.net -- property is theft.
8 # This program is free software; you can redistribute it and/or modify
9 # it under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 2 of the License, or
11 # (at your option) any later version.
13 # This program is distributed in the hope that it will be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16 # GNU General Public License for more details.
19 #####################################################
22 function setupcolors() {
30 COLORS=($BLUE $GREEN $YELLOW $RED $PURPLE)
34 if [ "$usecolors" == "yes" ]; then
35 local typestr=`echo "$@" | sed 's/\(^[^:]*\).*$/\1/'`
36 [ "$typestr" == "Debug" ] && type=0
37 [ "$typestr" == "Info" ] && type=1
38 [ "$typestr" == "Warning" ] && type=2
39 [ "$typestr" == "Error" ] && type=3
40 [ "$typestr" == "Fatal" ] && type=4
41 color=${COLORS[$type]}
43 echo -e "$color$@$endcolor"
49 # We have the following message levels:
51 # 1 - normal messages - green
52 # 2 - warnings - yellow
55 # First variable passed is the error level, all others are printed
57 # if 1, echo out all warnings, errors, or fatal
58 # used to capture output from handlers
64 [ ${#@} -gt 1 ] || return
68 if [ $type == 100 ]; then
69 typestr=`echo "$@" | sed 's/\(^[^:]*\).*$/\1/'`
70 [ "$typestr" == "Debug" ] && type=0
71 [ "$typestr" == "Info" ] && type=1
72 [ "$typestr" == "Warning" ] && type=2
73 [ "$typestr" == "Error" ] && type=3
74 [ "$typestr" == "Fatal" ] && type=4
77 types=(Debug Info Warning Error Fatal)
78 typestr="${types[$type]}: "
83 if [ $echo_debug_msg == 1 ]; then
84 echo -e "$typestr$@" >&2
86 colorize "$typestr$@" >&2
89 if [ $print -lt $loglevel ]; then
95 if [ -w "$logfile" ]; then
96 echo -e `date "+%h %d %H:%M:%S"` "$@" >> $logfile
100 function passthru() {
122 messages[$msgcount]=$1
130 function setsection() {
135 # sets a global var with name equal to $1
136 # to the value of the configuration parameter $1
142 ret=`awk -f $scriptdir/parseini S=$CURRENT_SECTION P=$CURRENT_PARAM $CURRENT_CONF_FILE`
143 # if nothing is returned, set the default
144 if [ "$ret" == "" -a "$2" != "" ]; then
148 # replace * with %, so that it is not globbed.
149 ret="${ret//\\*/__star__}"
151 # this is weird, but single quotes are needed to
152 # allow for returned values with spaces. $ret is still expanded
153 # because it is in an 'eval' statement.
158 # enforces very strict permissions on configuration file $file.
161 function check_perms() {
163 local perms=`ls -ld $file`
165 if [ "$perms" != "------" ]; then
166 echo "Configuration files must not be group or world writable/readable! Dying on file $file"
167 fatal "Configuration files must not be group or world writable/readable! Dying on file $file"
169 if [ `ls -ld $file | awk '{print $3}'` != "root" ]; then
170 echo "Configuration files must be owned by root! Dying on file $file"
171 fatal "Configuration files must be owned by root! Dying on file $file"
175 # simple lowercase function
177 echo "$1" | tr [:upper:] [:lower:]
180 # simple to integer function
182 echo "$1" | tr [:alpha:] -d
186 # function isnow(): returns 1 if the time/day passed as $1 matches
187 # the current time/day.
189 # format is <day> at <time>:
195 # we grab the current time once, since processing
196 # all the configs might take more than an hour.
199 nowdayofweek=`date +%A`
200 nowdayofweek=`tolower "$nowdayofweek"`
205 whendayofweek=$1; at=$2; whentime=$3;
206 whenday=`toint "$whendayofweek"`
207 whendayofweek=`tolower "$whendayofweek"`
208 whentime=`echo "$whentime" | sed 's/:[0-9][0-9]$//' | sed -r 's/^([0-9])$/0\1/'`
210 if [ "$whendayofweek" == "everyday" -o "$whendayofweek" == "daily" ]; then
211 whendayofweek=$nowdayofweek
214 if [ "$whenday" == "" ]; then
215 if [ "$whendayofweek" != "$nowdayofweek" ]; then
216 whendayofweek=${whendayofweek%s}
217 if [ "$whendayofweek" != "$nowdayofweek" ]; then
221 elif [ "$whenday" != "$nowday" ]; then
225 [ "$at" == "at" ] || return 0
226 [ "$whentime" == "$nowtime" ] || return 0
234 This script allows you to coordinate system backup by dropping a few
235 simple configuration files into /etc/backup.d/. Typically, this
236 script is run hourly from cron.
238 The following options are available:
239 -h, --help This usage message
240 -d, --debug Run in debug mode, where all log messages are
241 output to the current shell.
242 -f, --conffile FILE Use FILE for the main configuration instead
243 of /etc/backupninja.conf
244 -t, --test Test run mode. This will test if the backup
245 could run, without actually preforming any
246 backups. For example, it will attempt to authenticate
247 or test that ssh keys are set correctly.
248 -n, --now Perform actions now, instead of when they might
249 be scheduled. No output will be created unless also
251 --run FILE Execute the specified action file and then exit.
252 Also puts backupninja in debug mode.
254 When in debug mode, output to the console will be colored:
257 debug "Debugging info (when run with -d)"
258 info "Informational messages (verbosity level 4)"
259 warning "Warnings (verbosity level 3 and up)"
260 error "Errors (verbosity level 2 and up)"
261 fatal "Fatal, halting errors (always shown)"
265 ## this function handles the running of a backup action
267 ## these globals are modified:
268 ## fatals, errors, warnings, actions_run, errormsg
271 function process_action() {
277 # skip over this config if "when" option
278 # is not set to the current time.
279 getconf when "$defaultwhen"
280 if [ "$processnow" == 1 ]; then
281 info ">>>> starting action $file (because of --now)"
283 elif [ "$when" == "hourly" ]; then
284 info ">>>> starting action $file (because 'when = hourly')"
293 if [ $ret == 0 ]; then
294 debug "skipping $file because it is not $w"
296 info ">>>> starting action $file (because it is $w)"
303 [ "$run" == "no" ] && return
305 let "actions_run += 1"
308 local bufferfile="/tmp/backupninja.buffer.$$"
309 echo "" > $bufferfile
312 . $scriptdir/$suffix $file
315 echo $a >> $bufferfile
316 [ $debug ] && colorize "$a"
320 # ^^^^^^^^ we have a problem! we can't grab the return code "$?". grrr.
323 _warnings=`cat $bufferfile | grep "^Warning: " | wc -l`
324 _errors=`cat $bufferfile | grep "^Error: " | wc -l`
325 _fatals=`cat $bufferfile | grep "^Fatal: " | wc -l`
327 ret=`grep "\(^Warning: \|^Error: \|^Fatal: \)" $bufferfile`
329 if [ $_fatals != 0 ]; then
330 msg "*failed* -- $file"
331 errormsg="$errormsg\n== fatal errors from $file ==\n\n$ret\n"
332 passthru "Fatal: <<<< finished action $file: FAILED"
333 elif [ $_errors != 0 ]; then
334 msg "*error* -- $file"
335 errormsg="$errormsg\n== errors from $file ==\n\n$ret\n"
336 error "<<<< finished action $file: ERROR"
337 elif [ $_warnings != 0 ]; then
338 msg "*warning* -- $file"
339 errormsg="$errormsg\n== warnings from $file ==\n\n$ret\n"
340 warning "<<<< finished action $file: WARNING"
342 msg "success -- $file"
343 info "<<<< finished action $file: SUCCESS"
346 let "fatals += _fatals"
347 let "errors += _errors"
348 let "warnings += _warnings"
351 #####################################################
355 conffile="/etc/backupninja.conf"
358 ## process command line options
360 while [ $# -ge 1 ]; do
363 -d|--debug) debug=1;;
364 -t|--test) test=1;debug=1;;
365 -n|--now) processnow=1;;
370 echo "-f|--conffile option must be followed by an existing filename"
371 fatal "-f|--conffile option must be followed by an existing filename"
374 # we shift here to avoid processing the file path
383 echo "--run option must be fallowed by a backupninja action file"
384 fatal "--run option must be fallowed by a backupninja action file"
391 echo "Unknown option $1"
392 fatal "Unknown option $1"
404 ## Load and confirm basic configuration values
407 if [ ! -r "$conffile" ]; then
408 echo "Configuration file $conffile not found."
409 fatal "Configuration file $conffile not found."
412 scriptdir=`grep scriptdirectory $conffile | awk '{print $3}'`
413 if [ ! -n "$scriptdir" ]; then
414 echo "Cound not find entry 'scriptdirectory' in $conffile"
415 fatal "Cound not find entry 'scriptdirectory' in $conffile"
418 if [ ! -d "$scriptdir" ]; then
419 echo "Script directory $scriptdir not found."
420 fatal "Script directory $scriptdir not found."
425 # get global config options (second param is the default)
426 getconf configdirectory /etc/backup.d
428 getconf reportsuccess yes
429 getconf reportwarning yes
431 getconf when "Everyday at 01:00"
433 getconf logfile /var/log/backupninja.log
434 getconf usecolors "yes"
435 getconf SLAPCAT /usr/sbin/slapcat
436 getconf LDAPSEARCH /usr/bin/ldapsearch
437 getconf RDIFFBACKUP /usr/bin/rdiff-backup
438 getconf MYSQL /usr/bin/mysql
439 getconf MYSQLHOTCOPY /usr/bin/mysqlhotcopy
440 getconf MYSQLDUMP /usr/bin/mysqldump
441 getconf PGSQLDUMP /usr/bin/pg_dump
442 getconf PGSQLDUMPALL /usr/bin/pg_dumpall
443 getconf GZIP /bin/gzip
444 getconf RSYNC /usr/bin/rsync
446 getconf VSERVERINFO /usr/sbin/vserver-info
447 getconf VSERVER /usr/sbin/vserver
448 getconf VROOTDIR `if [ -f "$VSERVERINFO" ]; then $VSERVERINFO info SYSINFO |grep vserver-Rootdir | awk '{print $2}'; fi`
450 if [ ! -d "$configdirectory" ]; then
451 echo "Configuration directory '$configdirectory' not found."
452 fatal "Configuration directory '$configdirectory' not found."
455 [ -f "$logfile" ] || touch $logfile
457 if [ "$UID" != "0" ]; then
458 echo "$0 can only be run as root"
462 if [ "$vservers" == "yes" -a ! -d "$VROOTDIR" ]; then
463 echo "vservers option set in config, but $VROOTDIR is not a directory!"
464 fatal "vservers option set in config, but $VROOTDIR is not a directory!"
467 ## Process each configuration file
469 # by default, don't make files which are world or group readable.
472 # these globals are set by process_action()
479 if [ "$singlerun" ]; then
482 files=`find $configdirectory ! -name '.*.swp' -mindepth 1 | sort -n`
485 for file in $files; do
486 [ -f "$file" ] || continue
490 base=`basename $file`
491 if [ "${base:0:1}" == "0" -o "$suffix" == "disabled" ]; then
492 info "Skipping $file"
496 if [ -e "$scriptdir/$suffix" ]; then
497 process_action $file $suffix
499 error "Can't process file '$file': no handler script for suffix '$suffix'"
500 msg "*missing handler* -- $file"
504 ## mail the messages to the report address
506 if [ $actions_run == 0 ]; then doit=0
507 elif [ "$reportemail" == "" ]; then doit=0
508 elif [ $fatals != 0 ]; then doit=1
509 elif [ $errors != 0 ]; then doit=1
510 elif [ "$reportsuccess" == "yes" ]; then doit=1
511 elif [ "$reportwarning" == "yes" -a $warnings != 0 ]; then doit=1
515 if [ $doit == 1 ]; then
516 debug "send report to $reportemail"
518 [ $warnings == 0 ] || subject="WARNING"
519 [ $errors == 0 ] || subject="ERROR"
520 [ $fatals == 0 ] || subject="FAILED"
523 for ((i=0; i < ${#messages[@]} ; i++)); do
527 } | mail $reportemail -s "backupninja: $hostname $subject"
530 if [ $actions_run != 0 ]; then
531 info "FINISHED: $actions_run actions run. $fatals fatal. $errors error. $warnings warning."